'''Game main module.

Contains the entry point used by the run_game.py script.

Feel free to put all your game code here, or in other modules in this "gamelib"
package.
'''

import data
import pygame
import random
import time
import sys
import math
from pygame.locals import *

def loadIm(name):
    file = data.filepath(name)
    try:
        image = pygame.image.load(file)
        return image.convert_alpha()
    except:
        name = 'error.png'
        print 'Could not load:', file
        file = data.filepath(name)
        image = pygame.image.load(file)
        return image.convert_alpha()


def Music(music_file):
    music_file = data.filepath(music_file)
    try:
        pygame.mixer.music.load(music_file)
    except pygame.error:
        print 'music not loaded'
    pygame.mixer.music.play()



class menu(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = loadIm("Menu.png")
        self.rect = self.image.get_rect()
        self.x = 300
        self.y = 250
        self.rect.center = (self.x, self.y)
        pygame.sprite.Sprite.__init__(self)

class Label(pygame.sprite.Sprite):
    def __init__(self, text, y):
        pygame.sprite.Sprite.__init__(self)
        text = text + ".png"
        self.image = loadIm(text)
        self.rect = self.image.get_rect()
        self.x = 300
        self.y = y
        self.type = "Label"
        self.rect.center = (self.x, self.y)
        pygame.sprite.Sprite.__init__(self)
    def update(self):
        pass
        


class Select(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = loadIm("Select.png")
        self.rect = self.image.get_rect()
        self.x = 300
        self.y = 250
        self.type = 'Select'
        self.rect.center = (self.x, self.y)
        pygame.sprite.Sprite.__init__(self)
    def update(self):
        if self.y == 250:
            self.y = 350
        else:
            self.y = 250
        self.rect.center = (self.x, self.y)


class Meadow(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self)
        self.image = loadIm("Meadow.png")
        self.rect = self.image.get_rect()
        self.x = 300
        self.y = 250
        self.type = 'Meadow'
        self.rect.center = (self.x, self.y)
        pygame.sprite.Sprite.__init__(self)

class Bottle(pygame.sprite.Sprite):
    def __init__(self):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("Bottle.png")
        self.rect = self.image.get_rect()
        self.x = 600
        self.y = -200
        self.up = 0
        self.right = 0
        self.move = 4
        self.lastx = self.x
        self.lasty = self.y
        self.type = 'Bottle'
        self.rect.center = (self.x, self.y)
        pygame.sprite.Sprite.__init__(self)
    def update(self,collide,back):
        if collide == 1:
            self.x = self.lastx
            self.y = self.lasty
        self.lastx = self.x
        self.lasty = self.y
        if self.y < 800:
            if self.up == 1:
                self.y += self.move
        if self.y > -800:
            if self.up == -1:
                self.y -= self.move
        if self.x > -200:
            if self.right == 1:
                self.x -= self.move
        if self.x < 800:
            if self.right == -1:
                self.x += self.move
        if back == 1:
            self.x = 600
            self.y = -200
        self.rect.center = (self.x, self.y)




class Cloud(pygame.sprite.Sprite):
    def __init__(self,timer):
        pygame.sprite.Sprite.__init__(self)
        self.image = loadIm("Cloud.png")
        self.rect = self.image.get_rect()
        self.x = 300
        self.y = 250
        self.speed = 3
        self.move = 4
        self.up = 0
        self.right = 0
        self.lastx = self.x
        self.lasty = self.y
        self.timer = timer
        self.type = 'Cloud'
        self.rect.center = (self.x, self.y)
        pygame.sprite.Sprite.__init__(self)
    def update(self,up,right,backy,backx,collide):
        if self.timer < 1:
            self.timer = 8
            self.x = 300
            self.y = 250
        self.timer -= 1
        if backy < 800:
            if up == 1:
                if collide == 0:
                    self.y += self.move
                else:
                    self.y -= self.move
        if backy > -800:
            if up == -1:
                if collide == 0:
                    self.y -= self.move
                else:
                    self.y += self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.rect.center = (self.x, self.y)
        


class TheImages(pygame.sprite.Sprite):
    def __init__(self, im):
        pygame.sprite.Sprite.__init__(self)
        self.image = loadIm(im)
        self.rect = self.image.get_rect()
        self.x = 300
        self.y = 250
        self.active = 1
        self.type = 'TheImages'
        self.rect.center = (self.x, self.y)
        pygame.sprite.Sprite.__init__(self)
    def update(self,im):
        if im == '':
            self.image = loadIm("blank.png")
        else:
            self.image = loadIm(im)


class Gold(pygame.sprite.Sprite):
    def __init__(self,x,y):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("Gold.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.type = 'Gold'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.rect.center = (self.x, self.y)

class Invis(pygame.sprite.Sprite):
    def __init__(self,x,y):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("InvisiGold.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.type = 'Invis'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.rect.center = (self.x, self.y)


class Poison(pygame.sprite.Sprite):
    def __init__(self,x,y):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("Poison.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.angle =0
        self.timer = 200
        self.direction = 0
        self.type = 'Poison'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        if self.direction == 0:
            self.x += random.randint(-10,3)/1000
        else:
            self.x -= random.randint(-10,3)/1000
        if self.timer == 0:
            self.timer = 200
            if self.direction == 1:
                self.direction = 0
            else:
                self.direction = 1
        self.timer -= 1
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.rect.center = (self.x, self.y)


class BarrierH(pygame.sprite.Sprite):
    def __init__(self,x,y):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("BarrierH.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.type = 'BarrierH'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.rect.center = (self.x, self.y)


class BarrierV(pygame.sprite.Sprite):
    def __init__(self,x,y):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("BarrierV.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.type = 'BarrierV'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.rect.center = (self.x, self.y)



class ColourMe(pygame.sprite.Sprite):
    def __init__(self,x,y,texture):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm(texture)
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.type = 'ColourMe'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.rect.center = (self.x, self.y)






class RocketLauncher(pygame.sprite.Sprite):
    def __init__(self,x,y,speed):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("RocketLauncher.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.speed = int(speed)
        self.timer = int(speed)
        self.launch = 0
        self.type = 'RLauncher'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        self.launch = 0
        if self.timer == 0:
            self.launch = 1
            self.timer = self.speed
        self.timer -= 1
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        if self.y < 250:
            self.y += 1
        if self.y > 250:
            self.y -= 1
        self.rect.center = (self.x, self.y)





class RocketLauncherV(pygame.sprite.Sprite):
    def __init__(self,x,y,speed):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("RocketLauncherV.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.speed = int(speed)
        self.timer = int(speed)
        self.launch = 0
        self.type = 'RLauncherV'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        self.launch = 0
        if self.timer == 0:
            self.launch = 1
            self.timer = self.speed
        self.timer -= 1
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        if self.x < 300:
            self.x += 1
        if self.x > 300:
            self.x -= 1
        self.rect.center = (self.x, self.y)




class Hearts(pygame.sprite.Sprite):
    def __init__(self,x,y):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.I3 = loadIm("H3.png")
        self.I2 = loadIm("H2.png")
        self.I1 = loadIm("H1.png")
        self.I0 = loadIm("H0.png")
        self.image = self.I3
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.lives = 3
        self.type = 'Hearts'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx,lose):
        if lose == 1:
            self.lives -= 1
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        if self.lives == 3:
            self.image = self.I3
        if self.lives == 2:
            self.image = self.I2
        if self.lives == 1:
            self.image = self.I1
        if self.lives == 0:
            self.image = self.I0
        if self.y < 100:
            self.y += 3
        if self.y > 100:
            self.y -= 3
        self.rect.center = (self.x, self.y)




class Boss(pygame.sprite.Sprite):
    def __init__(self,x,y,speed):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("MWG.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.speed = int(speed)
        self.timer = int(speed)
        self.launch = 0
        self.type = 'Boss'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        self.launch = 0
        if self.timer == 0:
            self.launch = 1
            self.timer = self.speed
        self.timer -= 1
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        if self.y < 250:
            self.y += 3
        if self.y > 250:
            self.y -= 3
        self.rect.center = (self.x, self.y)






class Rocket(pygame.sprite.Sprite):
    def __init__(self,x,y):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("Rocket.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.timer = 30
        self.type = 'Rocket'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        if self.timer == 0:
            self.kill()
        self.timer -= 1
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.x += 8
        self.rect.center = (self.x, self.y)


class RocketB(pygame.sprite.Sprite):
    def __init__(self,x,y):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("MB.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.timer = 60
        self.type = 'RocketB'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        if self.timer == 0:
            self.kill()
        self.timer -= 1
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.x -= 12
        self.rect.center = (self.x, self.y)



class Power(pygame.sprite.Sprite):
    def __init__(self,x,y):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("MB.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.start = self.x,self.y
        self.move = 4
        self.timer = 0
        self.hide = 0
        self.type = 'Power'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        if self.timer > 0:
            if self.hide == 0:
                self.x -= 1000
                self.y += 1000
            self.timer -= 1
            self.hide = 1
        else:
            if self.hide == 1:
                self.x += 1000
                self.y -= 1000
                self.hide = 0
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.rect.center = (self.x, self.y)






class RocketL(pygame.sprite.Sprite):
    def __init__(self,x,y):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("Rocket.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.timer = 100
        self.type = 'RocketL'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        if self.timer == 0:
            self.kill()
        self.timer -= 1
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.x += 8
        self.rect.center = (self.x, self.y)






class RocketV(pygame.sprite.Sprite):
    def __init__(self,x,y):
        pygame.sprite.Sprite.__init__(self,self.containers)
        self.image = loadIm("RocketV.png")
        self.rect = self.image.get_rect()
        self.x = int(x)
        self.y = int(y)
        self.move = 4
        self.timer = 30
        self.type = 'RocketV'
        self.rect.center = (self.x, self.y)
    def update(self,up,right,backy,backx):
        if self.timer == 0:
            self.kill()
        self.timer -= 1
        if backy < 800:
            if up == 1:
                self.y += self.move
        if backy > -800:
            if up == -1:
                self.y -= self.move
        if backx > -200:
            if right == 1:
                self.x -= self.move
        if backx < 800:
            if right == -1:
                self.x += self.move
        self.y += 8
        self.rect.center = (self.x, self.y)



def level(screen):
    levels = int(data.load('Levels.txt').readline())
    i = 0
    song = ''
    gold = pygame.sprite.Group()
    all = pygame.sprite.RenderUpdates()
    Gold.containers = gold, all
    Invis.containers = gold,all
    barriers = pygame.sprite.Group()
    lavabar = pygame.sprite.Group()
    BarrierH.containers = barriers, all, lavabar
    BarrierV.containers = barriers, all, lavabar
    poison = pygame.sprite.Group()
    Poison.containers = all, barriers
    RocketLauncher.containers = all
    Rocket.containers = all, barriers
    RocketLauncherV.containers = all
    RocketV.containers = all, barriers
    RocketL.containers = all, barriers
    boss = pygame.sprite.Group()
    Boss.containers = all, barriers, boss
    ColourMe.containers = all
    powerup = pygame.sprite.Group()
    rocketB = pygame.sprite.Group()
    RocketB.containers = all,rocketB
    Power.containers = powerup,all
    lives = pygame.sprite.Group()
    Hearts.containers = lives
    while i != levels:
        leveldata = data.load('Level'+str(i+1)+'.txt').readlines()
        start = 0
        for item in leveldata:
            parts = item.split(',')
            num = 0
            for item in range(len(parts)):
                parts[num] = (parts[num].replace('\r', '')).replace('\n','')
                num += 1
            if parts[0] == 'Image':
                theImages = pygame.sprite.Group(TheImages(parts[1]))
                start = 1
            elif start == 0:
                theImages = pygame.sprite.Group(TheImages('blank.png'))
            if parts[0] == 'Gold':
                Gold(parts[1],parts[2])
            if parts[0] == 'BarrierH':
                BarrierH(parts[1],parts[2])
            if parts[0] == 'BarrierV':
                BarrierV(parts[1],parts[2])
            if parts[0] == 'Poison':
                Poison(parts[1],parts[2])
            if parts[0] == 'RL':
                RocketLauncher(parts[1],parts[2],parts[3])
            if parts[0] == 'RLV':
                RocketLauncherV(parts[1],parts[2],parts[3])
            if parts[0] == 'Song':
                song = parts[1]
            if parts[0] == 'Invis':
                Invis(parts[1],parts[2])
            if parts[0] == 'Boss':
                Boss(parts[1],parts[2],parts[3])
                Hearts(int(parts[1])-30,int(parts[2])-150)
            if parts[0] == 'Pow':
                Power(parts[1],parts[2])
            if parts[0] == 'Colour':
                ColourMe(parts[1],parts[2],parts[3])


        bottle = pygame.sprite.Group()
        background = pygame.sprite.Group(Meadow()) #Try swapping these to fix
        Bottle.containers = bottle, background
        Bottle()
        clouds = pygame.sprite.Group(Cloud(0),Cloud(1),Cloud(2),Cloud(3),Cloud(4),Cloud(5),Cloud(6),Cloud(7))
        background.containers = background
        clouds.containers = clouds
        theImages.containers = theImages
        background.draw(screen)
        clouds.draw(screen)
        theImages.draw(screen)
        pygame.display.update()
        up = 0
        right = 0
        finish = 0
        while finish == 0:
            if not pygame.mixer.music.get_busy():
                Music(song)
            for event in pygame.event.get():
                if event.type == pygame.QUIT: 
                    sys.exit()
                if (event.type == KEYDOWN):
                    theImages.update('')
                    if event.key == K_UP:
                        for item in background:
                            if item.type == 'Bottle':
                                item.up = 1
                                up = 1
                    if event.key == K_DOWN:
                        for item in background:
                            if item.type == 'Bottle':
                                item.up = -1
                                up = -1
                    if event.key == K_LEFT:
                        for item in background:
                            if item.type == 'Bottle':
                                item.right = -1
                                right = -1
                    if event.key == K_RIGHT:
                        for item in background:
                            if item.type == 'Bottle':
                                item.right = 1
                                right = 1
                    if event.key == K_ESCAPE:
                        sys.exit()


                if (event.type == KEYUP):
                    if event.key == K_UP:
                        for item in background:
                            if item.type == 'Bottle':
                                item.up = 0
                                up = 0
                    if event.key == K_DOWN:
                        for item in background:
                            if item.type == 'Bottle':
                                item.up = -0
                                up = 0
                    if event.key == K_LEFT:
                        for item in background:
                            if item.type == 'Bottle':
                                item.right = -0
                                right = 0
                    if event.key == K_RIGHT:
                        for item in background:
                            if item.type == 'Bottle':
                                item.right = 0
                                right = 0
            for item in background:
                if item.type == 'Bottle':
                    bottley = item.y
                    bottlex = item.x
            
            collide = 0
            curi = i
            back = 0
            for sprite in clouds:
                if pygame.sprite.groupcollide (clouds, gold, 0, 0):
                    finish = 1
                if pygame.sprite.groupcollide (clouds, barriers, 0, 0) or pygame.sprite.groupcollide (clouds, poison, 0, 0):
                    clouds.empty()
                    gold.empty()
                    barriers.empty()
                    powerup.empty()
                    all.empty()
                    lives.empty()
                    leveldata = data.load('Level'+str(i+1)+'.txt').readlines()
                    start = 0
                    for item in leveldata:
                        parts = item.split(',')
                        num = 0
                        for item in range(len(parts)):
                            parts[num] = (parts[num].replace('\r', '')).replace('\n','')
                            num += 1
                        if parts[0] == 'Image':
                            theImages = pygame.sprite.Group(TheImages(parts[1]))
                            start = 1
                        elif start == 0:
                            theImages = pygame.sprite.Group(TheImages('blank.png'))
                        if parts[0] == 'Gold':
                            Gold(parts[1],parts[2])
                        if parts[0] == 'BarrierH':
                            BarrierH(parts[1],parts[2])
                        if parts[0] == 'BarrierV':
                            BarrierV(parts[1],parts[2])
                        if parts[0] == 'Poison':
                            Poison(parts[1],parts[2])
                        if parts[0] == 'RL':
                            RocketLauncher(parts[1],parts[2],parts[3])
                        if parts[0] == 'Song':
                            song = parts[1]
                        if parts[0] == 'Invis':
                            Invis(parts[1],parts[2])
                        if parts[0] == 'RLV':
                            RocketLauncherV(parts[1],parts[2],parts[3])
                        if parts[0] == 'Boss':
                            Boss(parts[1],parts[2],parts[3])
                            Hearts(int(parts[1])-30,int(parts[2])-150)
                        if parts[0] == 'Pow':
                            Power(parts[1],parts[2])
                        if parts[0] == 'Colour':
                            ColourMe(parts[1],parts[2],parts[3])
                    back = 1
                    clouds = pygame.sprite.Group(Cloud(0),Cloud(1),Cloud(2),Cloud(3),Cloud(4),Cloud(5),Cloud(6),Cloud(7))
            clouds.update(up,right,bottley,bottlex,collide)
            background.update(collide,back)
            all.update(up,right,bottley,bottlex)
            killer = 0
            for sprite in boss:
                if pygame.sprite.groupcollide (boss, rocketB, 0, 0):
                    killer = 1
                    for item in rocketB:
                        item.kill()
            for item in lives:
                if item.lives == 0:
                    for sprite in boss:
                        if sprite.type == 'Boss':
                            sprite.kill()
                            finish = 1
            lives.update(up,right,bottley,bottlex,killer)
            background.draw(screen)
            bottle.draw(screen)
            for item in all:
                if item.type == 'RLauncher':
                    if item.launch == 1:
                        Rocket(item.x,item.y)
            for item in all:
                if item.type == 'RLauncherV':
                    if item.launch == 1:
                        RocketV(item.x,item.y)
            for item in all:
                if item.type == 'Boss':
                    if item.launch == 1:
                        RocketL(item.x+40,item.y)
                        RocketL(item.x+40,item.y+28)
                        RocketL(item.x+40,item.y-28)
            for thing in bottle:
                pass#print thing.x, thing.y
            for sprite in clouds:
                if pygame.sprite.groupcollide (clouds, powerup, 0, 0):
                    RocketB(300,250)
                    for item in powerup:
                        item.timer = 50
            all.draw(screen)
            clouds.draw(screen)
            powerup.draw(screen)
            lives.draw(screen)
            theImages.draw(screen)
            pygame.display.update()
            time.sleep(0.05)
        clouds.empty()
        gold.empty()
        barriers.empty()
        powerup.empty()
        all.empty()
        lives.empty()
        start = 0
        
        i += 1
    a = 1
    theImages = pygame.sprite.Group(TheImages('Win.png'))
    theImages.draw(screen)
    pygame.display.update()
    time.sleep(3)
    while a == 1:
        for event in pygame.event.get():
            if (event.type == KEYDOWN):
                theImages.update('')
                a = 0
        theImages.draw(screen)
        pygame.display.update()



def main(): 
    pygame.init()
    screen = pygame.display.set_mode((600, 500), 0, 32)
    screen.fill((255,255,255))
    pygame.display.set_caption('Mad Science - the game.')
    Music('clicky.mid')
    menusprite = pygame.sprite.Group(menu())
    newthings = pygame.sprite.Group(Label('Play', 250), Label('Quit', 350), Select())
    menusprite.containers = menusprite
    newthings.containers = menusprite
    menusprite.draw(screen)
    pygame.display.update()
    time.sleep(2)
    newthings.draw(screen)
    pygame.display.update()
    while True:
        if not pygame.mixer.music.get_busy():
            Music('clicky.mid')
        for event in pygame.event.get():
            if event.type == pygame.QUIT: 
                sys.exit()
            if (event.type == KEYDOWN):
                if event.key == K_RETURN:
                    for item in newthings:
                        if item.type == 'Select':
                            if item.y == 250:
                                level(screen)
                            else:
                                sys.exit()
                if event.key == K_ESCAPE:
                    sys.exit()
                newthings.update()
                menusprite.draw(screen)
                newthings.draw(screen)
                pygame.display.update()